addHook("PlayerThink", function(player)
	if ((player.playerstate == PST_LIVE) and not (player.powers[pw_carry]) and player.mo.state != S_PLAY_SUPER_TRANS1 and player.mo.state != S_PLAY_SUPER_TRANS2 and player.mo.state != S_PLAY_SUPER_TRANS3 and player.mo.state != S_PLAY_SUPER_TRANS4 and player.mo.state != S_PLAY_SUPER_TRANS5 and player.mo.state != S_PLAY_SUPER_TRANS6 and (player.mo.skin == "sonic" or player.mo.skin == "tails" or player.mo.skin == "knuckles" or player.mo.skin == "amy" or player.mo.skin == "fang" or player.mo.skin == "metalsonic" or player.mo.skin == "espio" or player.mo.skin == "mighty" or player.mo.skin == "charmy" or player.mo.skin == "vector" or player.mo.skin == "heavy" or player.mo.skin == "bomb" or player.mo.skin == "ray" or (player.mo.skin == "shadow" and not (player.sbike)) or player.mo.skin == "tangle" or player.mo.skin == "whisper" or player.mo.skin == "surge" or player.mo.skin == "trip"))
		player.jumpfactor = skins[player.mo.skin].jumpfactor
		if ((player.pflags & PF_SPINNING or player.pflags & PF_STARTDASH) and not (player.mo.skin == "vector" and player.cmd.buttons & BT_SPIN) and not (player.pflags & PF_JUMPED) and (P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR) and player.mo.skin != "heavy")
			player.normalspeed = 0
		elseif (player.mo.skin == "metalsonic" and player.dashmode >= 3*TICRATE and not (player.powers[pw_sneakers]) and not (player.powers[pw_super]))
			player.normalspeed = 5*(skins[player.mo.skin].normalspeed)/3
		else
			player.normalspeed = skins[player.mo.skin].normalspeed
		end
		if (not (P_IsObjectOnGround(player.mo)) and not (player.mo.eflags & MFE_JUSTHITFLOOR) and player.pflags & PF_BOUNCING)
			player.thrustfactor = 8*skins[player.mo.skin].thrustfactor/3
		elseif (not (P_IsObjectOnGround(player.mo)) and not (player.climbing) and not (player.mo.eflags & MFE_JUSTHITFLOOR) and not (player.pflags & PF_BOUNCING))
			player.thrustfactor = 2*skins[player.mo.skin].thrustfactor
		elseif ((player.mo.skin == "heavy" or player.mo.state == S_PLAY_SPINDASH or (player.mo.skin == "vector" and player.mo.state == S_VECTOR_SPINDASH)) and (player.pflags & PF_SPINNING or player.pflags & PF_STARTDASH) and (P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR))
			player.thrustfactor = 0
		else
			player.thrustfactor = skins[player.mo.skin].thrustfactor
		end
		if (player.mo.skin == "sonic" or player.mo.skin == "tails" or player.mo.skin == "knuckles" or player.mo.skin == "metalsonic" or player.mo.skin == "mighty" or player.mo.skin == "ray" or player.mo.skin == "espio" or player.mo.skin == "charmy" or player.mo.skin == "vector" or player.mo.skin == "bomb" or player.mo.skin == "shadow" or player.mo.skin == "surge" or player.mo.skin == "trip")
			if (player.mo.eflags & MFE_UNDERWATER and player.mo.skin != "metalsonic" and not (player.powers[pw_super]) and not (player.powers[pw_sneakers]))
				player.mindash = 18*FRACUNIT
				player.maxdash = 30*FRACUNIT
			elseif (player.mo.eflags & MFE_UNDERWATER and (player.mo.skin == "metalsonic" or player.powers[pw_super] or player.powers[pw_sneakers]))
				player.mindash = 30*FRACUNIT
				player.maxdash = 30*FRACUNIT
			elseif (not (player.mo.eflags & MFE_UNDERWATER) and player.mo.skin != "metalsonic" and not (player.powers[pw_super]) and not (player.powers[pw_sneakers]))
				player.mindash = 36*FRACUNIT
				player.maxdash = 60*FRACUNIT
			elseif (not (player.mo.eflags & MFE_UNDERWATER) and (player.mo.skin == "metalsonic" or player.powers[pw_super] or player.powers[pw_sneakers]))
				player.mindash = 60*FRACUNIT
				player.maxdash = 60*FRACUNIT
			end
		end
		if (P_IsObjectOnGround(player.mo) and not (player.mo.eflags & MFE_JUSTHITFLOOR))
			player.charflags = $|SF_RUNONWATER
		else
			player.charflags = $ & ~SF_RUNONWATER
		end
		if ((player.pflags & PF_SPINNING or player.pflags & PF_STARTDASH) and player.mo.skin != "charmy" and player.mo.skin != "heavy" and player.mo.skin != "bomb")
			if (player.pflags & PF_JUMPED and not (player.pflags & PF_THOKKED))
				player.pflags = $ & ~(PF_SPINNING|PF_THOKKED)
			elseif (player.mo.skin == "vector" and player.cmd.buttons & BT_SPIN and (P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR))
				player.pflags = $ & ~PF_THOKKED
			else
				player.pflags = $|PF_THOKKED
			end
			if ((P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR) and player.speed > 5*FRACUNIT and not (player.pflags & PF_STARTDASH))
				if (player.powers[pw_super] or player.powers[pw_sneakers] or (player.mo.skin == "metalsonic" and player.dashmode >= 3*TICRATE))
					P_Thrust(player.mo, R_PointToAngle2(0, 0, player.rmomx, player.rmomy), -(3*FRACUNIT/10))
				else
					P_Thrust(player.mo, R_PointToAngle2(0, 0, player.rmomx, player.rmomy), -(FRACUNIT/4))
				end
			end
		elseif ((player.mo.skin == "charmy" or player.mo.skin == "heavy") and (player.pflags & PF_SPINNING or player.pflags & PF_STARTDASH))
			if ((P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR) and player.speed > 5*FRACUNIT and not (player.pflags & PF_STARTDASH) and player.mo.skin == "charmy")
				if (player.powers[pw_super] or player.powers[pw_sneakers])
					P_Thrust(player.mo, R_PointToAngle2(0, 0, player.rmomx, player.rmomy), -(3*FRACUNIT/10))
				else
					P_Thrust(player.mo, R_PointToAngle2(0, 0, player.rmomx, player.rmomy), -(FRACUNIT/4))
				end
			end
			player.pflags = $|PF_SPINNING|PF_THOKKED
		end
		if ((player.mo.skin == "sonic" or player.mo.skin == "tails" or player.mo.skin == "knuckles" or player.mo.skin == "metalsonic" or player.mo.skin == "espio" or player.mo.skin == "mighty" or player.mo.skin == "ray" or player.mo.skin == "shadow" or player.mo.skin == "surge" or player.mo.skin == "trip") and (P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR) and player.cmd.buttons & BT_SPIN and not (player.plusbuttons & BT_SPIN) and player.skidtime)
			player.mo.state = S_PLAY_SPINDASH
			player.pflags = $|PF_STARTDASH|PF_SPINNING
			player.pflags = $ & ~PF_THOKKED
			P_InstaThrust(player.mo, player.mo.angle, 0)
			S_StartSound(player.mo, sfx_spndsh)
			player.dashspeed = player.mindash
		end
		if (player.secondjump == UINT8_MAX and player.pflags & PF_THOKKED and not (player.charflags & SF_NOJUMPSPIN))
			player.mo.state = S_PLAY_JUMP
			player.pflags = $|PF_JUMPED
			player.pflags = $ & ~(PF_SPINNING|PF_THOKKED|PF_SHIELDABILITY)
			player.secondjump = 0
		end
		if (player.mo.skin != "heavy" and player.pflags & PF_JUMPED and ((player.charflags & SF_NOJUMPSPIN and player.mo.state == S_PLAY_JUMP) or player.mo.state == S_PLAY_FLOAT or player.mo.state == S_PLAY_FLOAT_RUN or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL or (player.mo.skin == "mighty" and player.mo.state == S_MIGHTY_HAMMERDROP_SPRING)) and not (player.powers[pw_super]) and not (player.powers[pw_invulnerability]) and not (player.mo.skin == "metalsonic" and player.dashmode >= 3*TICRATE))
			player.pflags = $|PF_NOJUMPDAMAGE
		else
			player.pflags = $ & ~PF_NOJUMPDAMAGE
		end
		if (not (P_IsObjectOnGround(player.mo)) and not (player.mo.eflags & MFE_JUSTHITFLOOR) and ((player.charflags & SF_NOJUMPSPIN and player.mo.state == S_PLAY_JUMP) or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL or (player.mo.skin == "mighty" and player.mo.state == S_MIGHTY_HAMMERDROP_SPRING) or player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_SKID or player.mo.state == S_PLAY_WAIT or player.mo.state == S_PLAY_EDGE or player.mo.state == S_PLAY_FLOAT or player.mo.state == S_PLAY_FLOAT_RUN or player.mo.state == S_PLAY_DASH) and not (player.mo.skin == "metalsonic" and player.secondjump))
			player.pflags = $|PF_JUMPED
			player.pflags = $ & ~PF_SPINNING
			if (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_DASH)
				player.pflags = $ & ~PF_THOKKED
			end
			if not (player.mo.skin == "mighty" and player.mo.state == S_MIGHTY_HAMMERDROP_SPRING)
				if (player.mo.momz*P_MobjFlip(player.mo) > 0 and not (player.mo.skin == "trip" and player.powers[pw_super]))
					player.mo.state = S_PLAY_SPRING
				elseif (player.mo.momz*P_MobjFlip(player.mo) <= 0 and not (player.mo.skin == "trip" and player.powers[pw_super]))
					player.mo.state = S_PLAY_FALL
				end
			end
		end
		if (player.pflags & PF_SHIELDABILITY and not (P_IsObjectOnGround(player.mo)) and not (player.mo.eflags & MFE_JUSTHITFLOOR))
			player.pflags = $|PF_SPINNING|PF_THOKKED
			if (player.mo.state != S_PLAY_JUMP and not (player.charflags & SF_NOJUMPSPIN) and player.mo.skin != "amy")
				player.mo.state = S_PLAY_JUMP
			elseif (player.mo.state != S_PLAY_ROLL and (player.mo.skin == "amy" or player.charflags & SF_NOJUMPSPIN))
				player.mo.state = S_PLAY_ROLL
			end
		end
		if (not (P_IsObjectOnGround(player.mo)) and not (player.mo.eflags & MFE_JUSTHITFLOOR) and ((player.charflags & SF_NOJUMPSPIN and player.mo.state == S_PLAY_JUMP) or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL or (player.mo.skin == "mighty" and player.mo.state == S_MIGHTY_HAMMERDROP_SPRING) or player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_SKID or player.mo.state == S_PLAY_WAIT or player.mo.state == S_PLAY_EDGE or player.mo.state == S_PLAY_FLOAT or player.mo.state == S_PLAY_FLOAT_RUN or player.mo.state == S_PLAY_DASH) and player.secondjump != 2)
			player.pflags = $|PF_JUMPED
			player.pflags = $ & ~PF_SPINNING
			if (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_DASH)
				player.pflags = $ & ~PF_THOKKED
			end
			if not (player.mo.skin == "mighty" and player.mo.state == S_MIGHTY_HAMMERDROP_SPRING)
				if (player.mo.momz*P_MobjFlip(player.mo) > 0 and not (player.mo.skin == "trip" and player.powers[pw_super]))
					player.mo.state = S_PLAY_SPRING
				elseif (player.mo.momz*P_MobjFlip(player.mo) <= 0 and not (player.mo.skin == "trip" and player.powers[pw_super]))
					player.mo.state = S_PLAY_FALL
				end
			end
		end
		if (player.pflags & PF_SHIELDABILITY and not (P_IsObjectOnGround(player.mo)) and not (player.mo.eflags & MFE_JUSTHITFLOOR))
			player.pflags = $|PF_SPINNING|PF_THOKKED
			if (player.mo.state != S_PLAY_JUMP and player.mo.skin != "amy" and not (player.charflags & SF_NOJUMPSPIN))
				player.mo.state = S_PLAY_JUMP
			elseif (player.mo.state != S_PLAY_ROLL and (player.mo.skin == "amy" or player.charflags & SF_NOJUMPSPIN))
				player.mo.state = S_PLAY_ROLL
			end
		end
		if (((player.powers[pw_super] and player.mo.skin == "sonic") or player.mo.skin == "metalsonic") and (player.mo.skin == "sonic" or player.mo.skin == "tails" or player.mo.skin == "knuckles" or player.mo.skin == "metalsonic" or player.mo.skin == "espio" or player.mo.skin == "mighty" or player.mo.skin == "vector" or player.mo.skin == "shadow" or player.mo.skin == "ray") and player.pflags & PF_JUMPED and not (player.pflags & PF_THOKKED) and player.cmd.buttons & BT_SPIN and not (player.plusbuttons & BT_SPIN))
			player.secondjump = 2
		end
		if (player.secondjump == 2 and (player.mo.skin == "sonic" or player.mo.skin == "metalsonic"))
			player.pflags = $ | PF_JUMPED | PF_THOKKED
			player.secondjump = 2
			player.mo.flags = $ | MF_NOGRAVITY
			if (player.speed < player.runspeed)
				player.mo.state = S_PLAY_FLOAT
			elseif (player.speed >= player.runspeed and not (player.dashmode >= 3*TICRATE))
				player.mo.state = S_PLAY_FLOAT_RUN
			elseif (player.speed >= player.runspeed and player.dashmode >= 3*TICRATE)
				player.mo.state = S_PLAY_DASH
			end
			if (player.cmd.buttons & BT_JUMP and not (player.cmd.buttons & BT_SPIN))
				if P_MobjFlip(player.mo)*player.mo.momz < 5*FRACUNIT
					P_SetObjectMomZ(player.mo, FRACUNIT/2, true)
				elseif P_MobjFlip(player.mo)*player.mo.momz > 5*FRACUNIT
					P_SetObjectMomZ(player.mo, -(FRACUNIT/2), true)
				end
			elseif (player.cmd.buttons & BT_SPIN and not (player.cmd.buttons & BT_JUMP))
				if P_MobjFlip(player.mo)*player.mo.momz > -(5*FRACUNIT)
					P_SetObjectMomZ(player.mo, -(FRACUNIT/2), true)
				elseif P_MobjFlip(player.mo)*player.mo.momz < -(5*FRACUNIT)
					P_SetObjectMomZ(player.mo, FRACUNIT/2, true)
				end
			elseif (not (player.cmd.buttons & BT_JUMP) and not (player.cmd.buttons & BT_SPIN))
				if P_MobjFlip(player.mo)*player.mo.momz > 0
					P_SetObjectMomZ(player.mo, -(FRACUNIT/2), true)
				elseif P_MobjFlip(player.mo)*player.mo.momz < 0
					P_SetObjectMomZ(player.mo, FRACUNIT/2, true)
				end
			elseif (player.cmd.buttons & BT_JUMP and player.cmd.buttons & BT_SPIN)
				player.mo.state = S_PLAY_JUMP
				player.pflags = $|PF_JUMPED|PF_SPINNING|PF_THOKKED
				player.secondjump = 0
				P_SpawnThokMobj(player)
				if (player.mo.skin == "sonic" or player.mo.skin == "metalsonic")
					S_StartSound(player.mo, sfx_thok)
				else
					S_StartSound(player.mo, sfx_zoom)
				end
				if ((player.mo.skin == "sonic" or player.mo.skin == "metalsonic") and (player.cmd.forwardmove or player.cmd.sidemove))
					P_InstaThrust(player.mo, player.mo.angle, player.actionspd)
					if (player.mo.skin == "metalsonic" and player.dashmode < 3*TICRATE)
						if not (maptol & TOL_NIGHTS)
							player.dashmode = 3*TICRATE
							S_StartSound(player.mo, sfx_kc4d)
						end
					end
				elseif not (player.cmd.forwardmove) and not (player.cmd.sidemove)
					P_InstaThrust(player.mo, player.mo.angle, 0)
				end
				P_SetObjectMomZ(player.mo, -(24*FRACUNIT), false)
			end
		else
			player.mo.flags = $ & ~MF_NOGRAVITY
		end
		if (player.mo.skin == "sonic" or player.mo.skin == "metalsonic")
			if (player.mo.eflags & MFE_UNDERWATER)
				player.actionspd = 30*FRACUNIT
			else
				player.actionspd = 60*FRACUNIT
			end
		end
		if (player.mo.skin == "tails")
			if (not (P_IsObjectOnGround(player.mo)) and not (player.mo.eflags & MFE_JUSTHITFLOOR) and (player.mo.state == S_PLAY_FLY or player.mo.state == S_PLAY_FLY_TIRED or player.mo.state == S_PLAY_SWIM))				
				if (player.cmd.buttons & BT_JUMP and player.cmd.buttons & BT_SPIN)
					player.mo.state = S_PLAY_JUMP
					player.pflags = $|PF_JUMPED|PF_SPINNING|PF_THOKKED
				end
				if (player.mo.state != S_PLAY_FLY_TIRED)
					if (player.cmd.buttons & BT_JUMP)
						player.fly1 = 1
					else
						player.fly1 = 0
					end
				end
				if (player.powers[pw_tailsfly] > 3*TICRATE and not (player.powers[pw_super]))
					player.powers[pw_tailsfly] = 3*TICRATE
				end
			end
		end
		if (player.mo.skin == "knuckles")
			if player.momentumplusglidelast == nil
				player.momentumplusglidelast = 0
			end
			local gliding = player.pflags & PF_GLIDING
			local thokked = player.pflags & PF_THOKKED
			local exitglide = (player.momentumplusglidelast == 1 and not (gliding) and thokked)
			local landglide = (player.momentumplusglidelast == 2 and not (gliding|thokked))
			if ((exitglide or landglide) and (player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL or player.mo.state == S_PLAY_GLIDE or player.mo.state == S_PLAY_GLIDE_LANDING))
				player.mo.momx = $*2
				player.mo.momy = $*2
				if (exitglide)
					if (player.mo.state != S_PLAY_JUMP)
						player.mo.state = S_PLAY_JUMP
					end
					player.pflags = $|PF_JUMPED|PF_SPINNING|PF_THOKKED
					player.pflags = $ & ~(PF_NOJUMPDAMAGE|PF_GLIDING)
				end
			end
			if ((P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR) and player.pflags & PF_GLIDING)
				player.mo.state = S_PLAY_GLIDE_LANDING
				S_StartSound(player.mo, sfx_s3k4c)
				player.pflags = $ & ~PF_GLIDING
				player.skidtime = 0
			end
			if (gliding and (player.mo.state == S_PLAY_GLIDE or player.mo.state == S_PLAY_SWIM) and player.cmd.buttons & BT_JUMP and player.cmd.buttons & BT_SPIN)
				player.mo.state = S_PLAY_JUMP
				player.pflags = $|PF_JUMPED|PF_SPINNING|PF_THOKKED
				player.pflags = $ & ~PF_GLIDING
			end
			if gliding
				player.momentumplusglidelast = 1
			elseif exitglide
				player.momentumplusglidelast = 2
			elseif not(gliding|thokked)
				player.momentumplusglidelast = 0
			end
		end
		if (player.mo.skin == "amy")
			if (player.powers[pw_super])
				player.thokitem = MT_LHRT
				player.revitem = MT_LHRT
			else
				player.thokitem = MT_NULL
				player.revitem = MT_NULL
			end
			if (player.mo.state == S_PLAY_JUMP)
				player.mo.state = S_PLAY_TWINSPIN
				player.powers[pw_strong] = STR_TWINSPIN
				player.mo.frame = 0
			end
			if (player.mo.state == S_PLAY_MELEE or player.mo.state == S_PLAY_MELEE_FINISH or player.mo.state == S_PLAY_TWINSPIN)
				if (player.mo.state == S_PLAY_TWINSPIN)
					player.powers[pw_strong] = STR_TWINSPIN
					if (player.realmo.frame&FF_FRAMEMASK == 5)
						player.mo.state = S_PLAY_TWINSPIN
						player.powers[pw_strong] = STR_TWINSPIN
						player.mo.frame = 0
					end
				end
				if (player.mo.state == S_PLAY_MELEE or player.mo.state == S_PLAY_MELEE_FINISH)
					player.charability2 = CA2_MELEE
					player.powers[pw_strong] = STR_MELEE
					if (player.mo.state == S_PLAY_MELEE_FINISH)
						player.mo.state = S_PLAY_MELEE
					end
				end
			else
				player.charability2 = CA2_NONE
			end
			if (player.cmd.buttons & BT_SPIN and not (player.plusbuttons & BT_SPIN) and (player.pflags & PF_JUMPED or player.pflags & PF_SPINNING or P_IsObjectOnGround(player.mo)) and player.mo.state != S_PLAY_MELEE and player.mo.state != S_PLAY_MELEE_FINISH and player.mo.state != S_PLAY_MELEE_LANDING)
				P_ResetPlayer(player)
				player.pflags = $|PF_JUMPED|PF_SPINNING|PF_THOKKED
				player.mo.state = S_PLAY_MELEE
				player.drawangle = player.mo.angle
				player.skidtime = 0
				S_StartSound(player.mo, sfx_s3k42)
				if (P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR)
					if (player.mo.eflags & MFE_UNDERWATER)
						P_SetObjectMomZ(player.mo, 585*player.mindash/1000, false)
					else
						P_SetObjectMomZ(player.mo, player.mindash, false)
					end
					if (P_MobjFlip(player.mo)*player.mo.pmomz < 0)
						player.mo.momz = $+player.mo.pmomz
					elseif (P_MobjFlip(player.mo)*player.mo.pmomz >= 0)
						player.mo.pmomz = 0
					end
				elseif (not (P_IsObjectOnGround(player.mo)) and not (player.mo.eflags & MFE_JUSTHITFLOOR))
					if (not (player.cmd.forwardmove) and not (player.cmd.sidemove))
						P_InstaThrust(player.mo, player.mo.angle, 0)
						P_SetObjectMomZ(player.mo, -(24*FRACUNIT), false)
					else
						P_SetObjectMomZ(player.mo, -(24*FRACUNIT), false)
					end
				end
				if (player.cmd.forwardmove or player.cmd.sidemove)
					if (player.mo.eflags & MFE_UNDERWATER)
						P_InstaThrust(player.mo, player.mo.angle, 30*FRACUNIT)
					else
						P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
					end
				elseif (not (P_IsObjectOnGround(player.mo)) and not (player.mo.eflags & MFE_JUSTHITFLOOR))
					P_InstaThrust(player.mo, player.mo.angle, 0)
				end
			end
			if (player.mo.state == S_PLAY_MELEE_LANDING or (player.mo.state == S_PLAY_MELEE and player.mo.eflags & MFE_JUSTHITFLOOR) or (player.mo.state == S_PLAY_MELEE_FINISH and player.mo.eflags & MFE_JUSTHITFLOOR))
				if (player.cmd.buttons & BT_SPIN and not (player.cmd.buttons & BT_JUMP) and player.speed > 5*FRACUNIT)
					player.mo.state = S_PLAY_ROLL
					player.pflags = $|PF_SPINNING|PF_THOKKED
					player.pflags = $ & ~PF_JUMPED
					S_StartSound(player.mo, sfx_spin)
				elseif (player.cmd.buttons & BT_JUMP)
					P_DoJump(player, false)
					player.mo.state = S_PLAY_TWINSPIN
					player.powers[pw_strong] = STR_TWINSPIN
					player.pflags = $|PF_JUMPED
					player.pflags = $ & ~(PF_SPINNING|PF_THOKKED)
					S_StartSound(player.mo, sfx_jump)
					player.mo.frame = 0
				else
					if (player.speed == 0)
						player.mo.state = S_PLAY_STND
					elseif (player.speed > 0 and player.speed < player.runspeed)
						player.mo.state = S_PLAY_WALK
					elseif (player.speed >= player.runspeed)
						player.mo.state = S_PLAY_RUN
					end
					player.pflags = $ & ~(PF_SPINNING|PF_JUMPED|PF_THOKKED)
				end
			end
		end
		if (player.mo.skin == "fang")
			local fanglockon = P_LookForEnemies(player, false, true)
			local fangbullet = nil
			local fangbomb = nil
			if (fanglockon and fanglockon.valid)
				P_SpawnLockOn(player, fanglockon, mobjinfo[MT_LOCKON].spawnstate)
			end
			if player.momentumplusbouncelast == nil
				player.momentumplusbouncelast = false
			end
			if ((player.pflags & PF_BOUNCING and not (player.momentumplusbouncelast)) or (not (player.pflags & PF_BOUNCING) and player.momentumplusbouncelast) and (player.mo.state == S_PLAY_BOUNCE or player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_ROLL or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL))
				player.mo.momx = $*2
				player.mo.momy = $*2
				if (not (player.pflags & PF_BOUNCING) and player.momentumplusbouncelast and player.mo.state != S_PLAY_ROLL)
					player.mo.state = S_PLAY_ROLL
					player.pflags = $|PF_JUMPED|PF_THOKKED
					player.pflags = $ & ~(PF_SPINNING|PF_BOUNCING)
				end
			end
			if (player.cmd.buttons & BT_SPIN and not (player.plusbuttons & BT_SPIN) and not (player.weapondelay) and (P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR or player.pflags & PF_JUMPED or player.pflags & PF_BOUNCING or (player.pflags & PF_SPINNING and P_IsObjectOnGround(player.mo))) and player.mo.state != S_PLAY_FIRE and player.mo.state != S_PLAY_FIRE_FINISH and not (player.pflags & PF_JUMPED and player.pflags & PF_THOKKED and player.mo.state == S_PLAY_ROLL))
				player.mo.state = S_PLAY_FIRE
				player.pflags = $ & ~(PF_SPINNING|PF_JUMPED|PF_THOKKED|PF_BOUNCING)
				if (player.powers[pw_super])
					player.weapondelay = 6
				else
					player.weapondelay = TICRATE/2
				end
				if (not (P_IsObjectOnGround(player.mo)) and not (player.mo.eflags & MFE_JUSTHITFLOOR))
					player.mo.momz = $/2
				end
				if (fanglockon and fanglockon.valid)
					player.mo.angle = R_PointToAngle2(player.mo.x, player.mo.y, fanglockon.x, fanglockon.y)
					fangbullet = P_SpawnPointMissile(player.mo, fanglockon.x, fanglockon.y, fanglockon.z, player.revitem, player.mo.x, player.mo.y, player.mo.z)
				end
				if not (fanglockon and fanglockon.valid)
					fangbullet = P_SpawnPointMissile(player.mo, player.mo.x + P_ReturnThrustX(nil, player.mo.angle, FRACUNIT), player.mo.y + P_ReturnThrustY(nil, player.mo.angle, FRACUNIT), player.mo.z, player.revitem, player.mo.x, player.mo.y, player.mo.z)
				end
			end
			if (player.mo.state == S_PLAY_FIRE or player.mo.state == S_PLAY_FIRE_FINISH)
				player.charflags = $|SF_NOSKID
				player.pflags = $|PF_JUMPDOWN
				player.pflags = $ & ~PF_BOUNCING
				if not (player.weapondelay)
					player.pflags = $ & ~PF_BOUNCING
					if (P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR)
						if ((player.cmd.buttons & BT_SPIN or player.plusbuttons & BT_SPIN) and player.speed > FixedMul(5<<FRACBITS, player.mo.scale)) and not (player.cmd.buttons & BT_JUMP or player.plusbuttons & BT_JUMP)
							player.mo.state = S_PLAY_ROLL
							player.pflags = $|PF_SPINNING|PF_THOKKED
							S_StartSound(player.mo, sfx_spin)
						elseif (player.cmd.buttons & BT_JUMP or player.plusbuttons & BT_JUMP)
							P_DoJump(player, false)
							player.mo.state = S_PLAY_ROLL
							player.pflags = $|PF_JUMPED
							player.pflags = $ & ~(PF_SPINNING|PF_THOKKED)
							S_StartSound(player.mo, sfx_jump)
						else
							if (player.speed == 0)
								player.mo.state = S_PLAY_STND
							elseif (player.speed > 0 and player.speed < player.runspeed)
								player.mo.state = S_PLAY_WALK
							elseif (player.speed >= player.runspeed)
								player.mo.state = S_PLAY_RUN
							end
							player.pflags = $ & ~(PF_SPINNING|PF_THOKKED)
						end
					elseif (not (P_IsObjectOnGround(player.mo)) and not (player.mo.eflags & MFE_JUSTHITFLOOR))
						player.mo.state = S_PLAY_ROLL
						player.pflags = $|PF_JUMPED|PF_THOKKED
						player.pflags = $ & ~PF_SPINNING
					end
				end
			else
				player.charflags = $ & ~SF_NOSKID
			end
			if ((player.mo.state == S_PLAY_BOUNCE_LANDING or ((P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR) and (player.pflags & PF_BOUNCING or player.momentumplusbouncelast))))
				player.pflags = $|PF_JUMPDOWN
				if not (player.weapondelay)
					fangbomb = P_SpawnMobjFromMobj(player.mo,5*FRACUNIT,5*FRACUNIT,player.mo.height+5*FRACUNIT,MT_FBOMB)
					fangbomb.target = player.mo
					fangbomb.momz = 10*FRACUNIT
					player.weapondelay = 6
					S_StartSound(player.mo, sfx_s3k51)
				end
				if (player.cmd.forwardmove or player.cmd.sidemove)
					if (player.powers[pw_super] or player.powers[pw_sneakers]) and not (player.mo.eflags & MFE_UNDERWATER)
						P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
					elseif not (player.powers[pw_super]) and not (player.powers[pw_sneakers]) and not (player.mo.eflags & MFE_UNDERWATER)
						P_InstaThrust(player.mo, player.mo.angle, 36*FRACUNIT)
					elseif (player.powers[pw_super] or player.powers[pw_sneakers]) and (player.mo.eflags & MFE_UNDERWATER)
						P_InstaThrust(player.mo, player.mo.angle, 30*FRACUNIT)
					elseif not (player.powers[pw_super]) and not (player.powers[pw_sneakers]) and (player.mo.eflags & MFE_UNDERWATER)
						P_InstaThrust(player.mo, player.mo.angle, 18*FRACUNIT)
					end
				else
					P_InstaThrust(player.mo, player.mo.angle, 0)
				end
			end
			if ((P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR) and player.pflags & PF_SPINNING)
				player.pflags = $|PF_JUMPDOWN
				if (player.cmd.buttons & BT_JUMP and not (player.plusbuttons & BT_JUMP))
					P_DoJump(player, false)
					player.mo.state = S_PLAY_ROLL
					player.normalspeed = skins[player.mo.skin].normalspeed
					player.pflags = $|PF_JUMPED
					player.pflags = $ & ~(PF_SPINNING|PF_THOKKED)
					S_StartSound(player.mo, sfx_jump)
				end
			end
		end
		if (((player.mo.skin == "espio" and (player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_ROLL or player.mo.state == S_ESPIO_ROLL)) or (player.mo.skin == "surge" and (player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_ROLL))) and not (P_IsObjectOnGround(player.mo)) and not (player.mo.eflags & MFE_JUSTHITFLOOR) and player.pflags & PF_JUMPED and player.pflags & PF_THOKKED and not (player.pflags & PF_SHIELDABILITY))
			if (player.mo.state != S_PLAY_JUMP)
				player.mo.state = S_PLAY_JUMP
			end
			player.pflags = $|PF_SPINNING
		end
		if (player.mo.skin == "mighty" and not (P_IsObjectOnGround(player.mo)) and not (player.mo.eflags & MFE_JUSTHITFLOOR) and player.pflags & PF_JUMPED and player.pflags & PF_THOKKED and not (player.pflags & PF_SPINNING)and not (player.pflags & PF_SHIELDABILITY) and player.mo.state == S_PLAY_ROLL)
			player.mo.state = S_PLAY_JUMP
			player.pflags = $ | PF_JUMPED
			player.pflags = $ & ~(PF_SPINNING|PF_THOKKED)
			if (player.cmd.forwardmove or player.cmd.sidemove)
				if (player.powers[pw_super] or player.powers[pw_sneakers]) and not (player.mo.eflags & MFE_UNDERWATER)
					P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
				elseif not (player.powers[pw_super]) and not (player.powers[pw_sneakers]) and not (player.mo.eflags & MFE_UNDERWATER)
					P_InstaThrust(player.mo, player.mo.angle, 36*FRACUNIT)
				elseif (player.powers[pw_super] or player.powers[pw_sneakers]) and (player.mo.eflags & MFE_UNDERWATER)
					P_InstaThrust(player.mo, player.mo.angle, 30*FRACUNIT)
				elseif not (player.powers[pw_super]) and not (player.powers[pw_sneakers]) and (player.mo.eflags & MFE_UNDERWATER)
					P_InstaThrust(player.mo, player.mo.angle, 18*FRACUNIT)
				end
			else
				P_InstaThrust(player.mo, player.mo.angle, 0)
			end
		end
		if (player.mo.skin == "vector")
			if (not (P_IsObjectOnGround(player.mo)) and not (player.mo.eflags & MFE_JUSTHITFLOOR) and player.pflags & PF_THOKKED and (player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL or player.mo.state == S_PLAY_ROLL) and not (player.pflags & PF_SHIELDABILITY) and not (player.pflags & PF_SPINNING))
				if (player.mo.state != S_PLAY_JUMP)
					player.mo.state = S_PLAY_JUMP
				end
				player.pflags = $|PF_SPINNING
			end
			if (player.mo.state == S_VECTOR_BEATBASH and player.cmd.buttons & BT_SPIN)
				player.mo.state = S_PLAY_JUMP
				player.pflags = $|PF_JUMPED|PF_SPINNING|PF_THOKKED
			end
		end
		if (player.mo.skin == "heavy" and (player.pflags & PF_SPINNING or player.pflags & PF_STARTDASH) and player.mo.heavyvars.tics > 3)
			player.mo.heavyvars.tics = 3
			P_InstaThrust(player.mo, player.mo.angle, 50*FRACUNIT)
		end
		if (player.mo.skin == "bomb")
			if ((P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR) and (player.pflags & PF_SPINNING or player.pflags & PF_STARTDASH))
				player.pflags = $|PF_JUMPDOWN|PF_SPINNING|PF_THOKKED
				if not (player.pflags & PF_STARTDASH and player.mo.state == S_PLAY_SPINDASH)
					if (player.powers[pw_super] or player.powers[pw_sneakers])
						P_Thrust(player.mo, R_PointToAngle2(0, 0, player.rmomx, player.rmomy), -(3*FRACUNIT/10))
					else
						P_Thrust(player.mo, R_PointToAngle2(0, 0, player.rmomx, player.rmomy), -(FRACUNIT/4))
					end
				end
				if (player.cmd.buttons & BT_JUMP and not (player.plusbuttons & BT_JUMP))
					P_DoJump(player, false)
					S_StartSound(player.mo, sfx_jump)
					if (player.speed >= 18*FRACUNIT and not (player.pflags & PF_STARTDASH))
						player.mo.state = S_BOMB_TOPSPIN_FAST
						player.mo.tics = min(2, $)
					elseif (player.speed <= 12*FRACUNIT and not (player.pflags & PF_STARTDASH))
						player.mo.state = S_BOMB_TOPSPIN
						if (player.speed <= 12*FRACUNIT)
							player.mo.tics = 1
						end
					elseif (player.pflags & PF_STARTDASH)
						player.mo.state = S_PLAY_SPINDASH
					end
					player.pflags = $|PF_JUMPED
					player.pflags = $ & ~(PF_SPINNING|PF_THOKKED|PF_NOJUMPDAMAGE)
				end
			end
			if (not (P_IsObjectOnGround(player.mo)) and not (player.mo.eflags & MFE_JUSTHITFLOOR) and (player.pflags & PF_SPINNING or player.pflags & PF_STARTDASH))
				player.mo.bomb_thokked = 2 ^ 1
			end
			if ((P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR) and player.pflags & PF_SPINNING and player.cmd.buttons & BT_SPIN and not (player.plusbuttons & BT_SPIN) and not (player.mo.bomb_volatile) and not (player.pflags & PF_STARTDASH and player.mo.state == S_PLAY_SPINDASH))
				player.mo.state = S_PLAY_SPINDASH
				player.pflags = $|PF_SPINNING|PF_STARTDASH|PF_THOKKED
				player.mo.bomb_fusedash = true
				player.mo.bomb_fusedash_charge = 1
				player.mo.bomb_fusedash_frame = 0
				player.mo.bomb_fusedash_frametics = 3
				S_StartSound(mo, sfx_sc0a5h)
			end
		end
		if (player.mo.skin == "ray" and not (P_IsObjectOnGround(player.mo)) and not (player.mo.eflags & MFE_JUSTHITFLOOR) and player.pflags & PF_THOKKED and (player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_ROLL) and not (player.pflags & PF_SHIELDABILITY))
			if (player.mo.state != S_PLAY_JUMP)
				player.mo.state = S_PLAY_JUMP
			end
			player.pflags = $|PF_SPINNING
		end
		if (player.mo.skin == "shadow")
			if ((P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR) and player.pflags & PF_SPINNING and player.mo.state != S_PLAY_ROLL and player.mo.state != S_PLAY_SPINDASH)
				player.mo.state = S_PLAY_ROLL
			end
			if (not (P_IsObjectOnGround(player.mo)) and not (player.mo.eflags & MFE_JUSTHITFLOOR) and player.pflags & PF_JUMPED and player.pflags & PF_THOKKED and (player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_ROLL) and not (player.pflags & PF_SHIELDABILITY))
				player.pflags = $|PF_SPINNING
			end
		end
		if (player.mo.skin == "surge" and player.mo.state == S_PLAY_ROLL and player.pflags & PF_JUMPED)
			player.mo.state = S_PLAY_JUMP
		end
	end
	player.momentumplusbouncelast = (player.pflags & PF_BOUNCING > 0)
	player.plusbuttons = player.cmd.buttons
	player.plusmomz = player.mo.momz
end)
addHook("AbilitySpecial", function(player)
	if ((player.mo.skin == "sonic" or player.mo.skin == "metalsonic") and not (player.pflags & PF_THOKKED))
		if (player.mo.state != S_PLAY_JUMP)
			player.mo.state = S_PLAY_JUMP
		end
		if (player.cmd.forwardmove or player.cmd.sidemove)
			P_InstaThrust(player.mo, player.mo.angle, player.actionspd)
			if (player.mo.skin == "metalsonic" and player.dashmode < 3*TICRATE)
				if not (maptol & TOL_NIGHTS)
					player.dashmode = 3*TICRATE
					S_StartSound(player.mo, sfx_kc4d)
				end
			end
		else
			P_InstaThrust(player.mo, player.mo.angle, 0)
		end
		S_StartSound(player.mo, sfx_thok)
		P_SpawnThokMobj(player)
		if (player.cmd.buttons & BT_SPIN)
			player.pflags = $|PF_SPINNING|PF_THOKKED
			player.pflags = $ & ~(PF_STARTJUMP)
			P_SetObjectMomZ(player.mo, -(24*FRACUNIT), false)
		else
			if (player.mo.eflags & MFE_UNDERWATER)
				if (player.powers[pw_super] and not (player.charflags & SF_NOSUPERJUMPBOOST))
					P_SetObjectMomZ(player.mo, FixedMul(13*FRACUNIT, FixedDiv(117*FRACUNIT, 200*FRACUNIT)), false)
				elseif (maptol & TOL_NIGHTS)
					P_SetObjectMomZ(player.mo, FixedMul(18*FRACUNIT, FixedDiv(117*FRACUNIT, 200*FRACUNIT)), false)
				else
					P_SetObjectMomZ(player.mo, FixedMul(39*FRACUNIT/4, FixedDiv(117*FRACUNIT, 200*FRACUNIT)), false)
				end
			else
				if (player.powers[pw_super] and not (player.charflags & SF_NOSUPERJUMPBOOST))
					P_SetObjectMomZ(player.mo, 13*FRACUNIT, false)
				elseif (maptol & TOL_NIGHTS)
					P_SetObjectMomZ(player.mo, 18*FRACUNIT, false)
				else
					P_SetObjectMomZ(player.mo, 39*FRACUNIT/4, false)
				end
			end
			player.pflags = $|PF_SPINNING|PF_THOKKED|PF_STARTJUMP
		end
	end
end)
-- Repurposed Spam Dash Code by Starlight
addHook("SpinSpecial", function(player)
	if ((player.mo.skin == "sonic" or player.mo.skin == "tails" or player.mo.skin == "knuckles" or player.mo.skin == "metalsonic" or player.mo.skin == "espio" or player.mo.skin == "mighty" or player.mo.skin == "ray" or player.mo.skin == "shadow" or player.mo.skin == "surge" or player.mo.skin == "trip") and player.playerstate == PST_LIVE and not (player.powers[pw_carry]))
		if (player.speed > 5*FRACUNIT and player.pflags & PF_STARTDASH) then return true end
		if (P_IsObjectOnGround(player.mo) and player.pflags & PF_SPINNING and not (player.pflags & (PF_SPINDOWN|PF_STARTDASH))) then
			if (player.speed == 0)
				player.mo.state = S_PLAY_STND
			elseif (player.speed > 0 and player.speed < player.runspeed)
				player.mo.state = S_PLAY_WALK
			elseif (player.speed >= player.runspeed)
				player.mo.state = S_PLAY_RUN
			end
			player.pflags = $ & ~PF_SPINNING
			player.pflags = $|PF_SPINDOWN
			return true
		end
	end
end)
addHook("MobjDamage", function(enemy, mo, source)
	if ((mo and mo.valid) and not (P_IsObjectOnGround(mo)) and not (mo.eflags & MFE_JUSTHITFLOOR) and (mo.skin == "sonic" or mo.skin == "tails" or mo.skin == "knuckles" or mo.skin == "amy" or mo.skin == "fang" or mo.skin == "metalsonic" or mo.skin == "espio" or mo.skin == "mighty" or (mo.skin == "vector" and (mo.player.pflags & PF_SHIELDABILITY or mo.player.pflags & PF_SPINNING)) or mo.skin == "ray" or mo.skin == "shadow" or mo.skin == "tangle" or mo.skin == "whisper" or mo.skin == "surge" or mo.skin == "trip"))
		if ((enemy and enemy.valid) and (mo.state == S_PLAY_JUMP or mo.state == S_PLAY_SPRING or mo.state == S_PLAY_FALL or mo.state == S_PLAY_TWINSPIN or mo.state == S_PLAY_ROLL or (mo.skin == "espio" and mo.state == S_ESPIO_ROLL)))
			mo.player.pflags = $ & ~(PF_THOKKED|PF_SPINNING|PF_SHIELDABILITY)
			mo.player.pflags = $ | PF_JUMPED
		end
	end
end)
addHook("MobjDeath", function(enemy, mo, source)
	if ((mo and mo.valid) and not (P_IsObjectOnGround(mo)) and not (mo.eflags & MFE_JUSTHITFLOOR) and (mo.skin == "sonic" or mo.skin == "tails" or mo.skin == "knuckles" or mo.skin == "amy" or mo.skin == "fang" or mo.skin == "metalsonic" or mo.skin == "espio" or mo.skin == "mighty" or (mo.skin == "vector" and (mo.player.pflags & PF_SHIELDABILITY or mo.player.pflags & PF_SPINNING)) or mo.skin == "ray" or mo.skin == "shadow" or mo.skin == "tangle" or mo.skin == "whisper" or mo.skin == "surge" or mo.skin == "trip"))
		if ((enemy and enemy.valid) and (mo.state == S_PLAY_JUMP or mo.state == S_PLAY_SPRING or mo.state == S_PLAY_FALL or mo.state == S_PLAY_TWINSPIN or mo.state == S_PLAY_ROLL or (mo.skin == "espio" and mo.state == S_ESPIO_ROLL)))
			mo.player.pflags = $ & ~(PF_THOKKED|PF_SPINNING|PF_SHIELDABILITY)
			mo.player.pflags = $ | PF_JUMPED
		end
	end
end)